#version 120


uniform mat4 gbufferModelView;
uniform mat4 gbufferModelViewInverse;

uniform float frameTimeCounter;

varying vec4 color;
varying vec4 texcoord;
varying vec4 lmcoord;


void main()
{
	vec4 position = gbufferModelViewInverse * gl_ModelViewMatrix * gl_Vertex;
	
	float distanceSquared = position.x * position.x + position.z * position.z;
	
	position.y += 5.0 * sin(distanceSquared * sin((frameTimeCounter*20 + 36000)/143) / 1000);
	
	float y = position.y;
	float x = position.x;
	
	float om = sin(distanceSquared*sin((frameTimeCounter*20 + 36000)/256.0)/5000) * sin((frameTimeCounter*20 + 36000)/200.0);
	
	position.y = x*sin(om)+y*cos(om);
	position.x = x*cos(om)-y*sin(om);
	
	
	gl_Position = gl_ProjectionMatrix * gbufferModelView * position;
	
	gl_FogFragCoord = gl_Position.z;
	
	texcoord = gl_TextureMatrix[0] * gl_MultiTexCoord0;
	
	color = gl_Color;
	
	lmcoord = gl_TextureMatrix[1] * gl_MultiTexCoord1;
}